Tomato = {}

local function newTomato(x, y)
    local size = { x = 20, y = 20 }
    return {
        score = 15,
        expireAfterCollision = true,
        position = { x = x, y = y },
        size = size,
        drawAsRectangle = { size = size },
    }
end

local tomatoIndex = 1
local tomatoCache = {}
for i = 1, 100 do
    tomatoCache[i] = newTomato(-999, 999)
end

function Tomato.cacheSize()
    return #tomatoCache
end

-- Tomatos should be "initialized" almost always increasing in X value
function Tomato.get(x, y)
    local tomato = tomatoCache[tomatoIndex]
    tomato.position.x = x
    tomato.position.y = y

    tomatoIndex = tomatoIndex + 1
    if tomatoIndex > #tomatoCache then
        tomatoIndex = 1
    end

    return tomato
end
