---@alias XyPair { x: number, y: number }

---@alias Entity table

---@alias Collision { collisionBetween: Entity[] }

---@type Entity
local Entity = {}

T = {
    ---@type XyPair
    XyPair = { x = 1, y = 1 },
    bool = true,
    number = 0,
    numberArray = { 1, 2, 3 },
    str = "",
    marker = {},
    ---@type fun(self)
    SelfFunction = function(self) end,
    --- Actor
    CanBounce = {
        isSolid = true,
        flat = { x = 1, y = 1 },
        mult = { x = 1, y = 1 },
    },
    --- Receiver
    CanBeBounced = {
        flat = { x = 1, y = 1 },
        mult = { x = 1, y = 1 },
    },
    ---@type Collision
    Collision = { Entity, Entity },
}

---@generic T
---@param t T
---@return nil | T
function Maybe(t)
    return { maybe = t }
end
